<?php
/*
 * Created on 6 Aug 2007 
 * By julien reichel <julien.reichel@spinetix.com>
 */

$tabs=array("Basic","Advanced");
$title="Media Sources"; 
include ("prolog.php");

$spxNS = 'http://www.spinetix.com/namespace/1.0/spx';
$svgNS = 'http://www.w3.org/2000/svg';
$xlinkNS = 'http://www.w3.org/1999/xlink';

$config_name="/srv/raperca/spxconfig.xml";
// apply changes 
$input=$_POST;

$sourceList=array("Local Storage" => "spx://localserver/index.svg",
				  "Network Project" => "" 
				  );
$maxSource=2;
$maxServers=10;
$maxProjects=10;

$config = new DOMDocument;
$config->loadXML(file_get_contents($config_name));

$mediaMountFile="/etc/default/media-mount";
$mediaMount=file_get_contents($mediaMountFile);

$useUSB=false;
if (preg_match("/INTERNAL_USB_STORAGE=(.*)/",$mediaMount,$matches))
	$useUSB=$matches[1]=='yes';


$doShutdown=false;
$mustSave=false;
if (isset($input["update"]) ){
	$sourceIdx=0;
	$mediaSources=$config->getElementsByTagNameNS($svgNS,'animation');
	$mediaSourcesList=array();
	foreach ($mediaSources as $mediaSource) $mediaSourcesList[]=$mediaSource;
	foreach ($mediaSourcesList as $mediaSource) $mediaSource->parentNode->removeChild($mediaSource);
	$parent=$config->getElementsByTagName('sources');
	if ($parent->length<1) $parent=$config->appendChild($source->createElement('sources'));
	else $parent=$parent->item(0);
	$name="source$sourceIdx";
	$input["source$maxSource"]='spx://localserver/defaulticon.svg';
	while (isset($input[$name])){
		$animation=$config->createElementNS($svgNS,'svg:animation');
		$animation->setAttributeNS($xlinkNS,"xlink:href", $input[$name]);
		$animation->setAttribute("priority", $maxSource-$sourceIdx);
		$animation->setAttribute("xml:id", "animation_".$sourceIdx);
		$parent->appendChild($animation);
		$sourceIdx++;
		$name="source$sourceIdx";
	}
	
	
	$mustSave=true;
	
	if ( $useUSB != isset($input["enable_usb"]) ) {
	     $useUSB = isset($input["enable_usb"]);
	     if ($useUSB ) {
		  $mediaMount=preg_replace("/INTERNAL_USB_STORAGE=.*/","INTERNAL_USB_STORAGE=yes", $mediaMount);
	     } else {
		  $mediaMount=preg_replace("/INTERNAL_USB_STORAGE=.*/","INTERNAL_USB_STORAGE=no", $mediaMount);
	     }
	     save_file($mediaMountFile, $mediaMount);
	     echo "<h2>Status:</h2>";
	     echo "Unplug and replug attached USB storage devices, if any, for the change to take effect. Alternatively you may restart the system for the changes to take effect.<br/><br/>";
	}
}

if (isset($input["update"]) || (isset($input["update_adv"]))){
	$serverIdx=0;
	
	$vHosts=$config->getElementsByTagName('virtualHost');
	$vHostList=array();
	foreach ($vHosts as $vHost) $vHostList[]=$vHost;
	foreach ($vHostList as $vHost) $vHost->parentNode->removeChild($vHost);
	$parent=$config->getElementsByTagName('resource');
	if ($parent->length<1) $parent=$config->appendChild($config->createElement('resource'));
	else $parent=$parent->item(0);
	for ($serverIdx=0; $serverIdx<$maxProjects; $serverIdx++){
		if ( !isset($input['projectName'.$serverIdx]) || (!isset($input['projectHref'.$serverIdx]) && !isset($input['oldProjectHref'.$serverIdx])) ) continue;
		$name=$input['projectName'.$serverIdx];
		if (isset($input['projectHref'.$serverIdx]))
			$href=$input['projectHref'.$serverIdx];
		else
			$href=$input['oldProjectHref'.$serverIdx];
		
		if ($name!="" && $href!=""){
			$vHost=$config->createElement('virtualHost');
			$vHost->setAttribute("host", "project://$name");
			$vHost->setAttributeNS($xlinkNS,"xlink:href", $href);
			$vHost->setAttribute("xml:id", "virtualHost_".$serverIdx);
			$parent->appendChild($vHost);
		}
		
	}
	$mustSave=true;
}
$creds=$config->getElementsByTagName('credits');
$pass_conf_name="";
if ($creds->length>=1)
	$pass_conf_name=$creds->item(0)->getAttributeNS($xlinkNS,"href");
if ($pass_conf_name=="")
	$pass_conf_name="spxpasswd.xml";

if (strpos( $pass_conf_name,"://")===false && $pass_conf_name[0]!='/' )
	$pass_conf_name=dirname($config_name)."/".$pass_conf_name;
	
$pass_config = new DOMDocument;
if ( file_exists($pass_conf_name) )
	$pass_config->loadXML(file_get_contents($pass_conf_name));

if (isset($input["update_adv"])){
	$serverIdx=0;
	
	$creds=$pass_config->getElementsByTagName('creditentials');
	$credsList=array();
	foreach ($creds as $cred) $credsList[]=$cred;
	foreach ($credsList as $cred)
		if ( ! $cred->hasAttribute("xml:id") )
			$cred->parentNode->removeChild($cred);
	$parent=$pass_config->getElementsByTagName('credits');
	if ($parent->length<1) $parent=$pass_config->appendChild($pass_config->createElement('credits'));
	else $parent=$parent->item(0);
	for ($serverIdx=0; $serverIdx<$maxProjects; $serverIdx++){
		if ( !isset($input['serverName'.$serverIdx]) ) continue;
		$name=$input['serverName'.$serverIdx];
		$pass=$input['serverPass'.$serverIdx];
		$realm=$input['serverRealm'.$serverIdx];
		$href=$input['serverHref'.$serverIdx];
		
		if ($name!="" ){
			$cred=$pass_config->createElement('creditentials');
			$cred->setAttribute("username", $name);
			$cred->setAttribute("password", $pass);
			$cred->setAttribute("realm", $realm);
			$cred->setAttributeNS($xlinkNS,"xlink:href", $href);
			$parent->appendChild($cred);
		}
		
	}
	save_file($pass_conf_name,$pass_config->saveXML(), true);
}

if ($mustSave) {
	save_file($config_name,$config->saveXML());
	if ( ! $doShutdown )
	     reconfig_player();
}
	
	
if (isset($input['clear_hmp100'])){
	exec('/etc/raperca/resetcontent --internal');
}

if (isset($input["format_usb"]) ){
	$dest=$input["usb_key"];
	echo "<h2>Status:</h2>";
	echo "USB storage formating in progress ".str_repeat(' ',256)."\n"; 
	ob_flush();flush();
	$flag="";
	$forced=isset($input["force_format"]);
	if ($forced) $flag="-f ";
	$format=exec("/usr/lib/raperca/content-format $flag$dest", $stdout, $ret);
	$formatMsg=array(0 => ": Sucess<br/><br/>Unplug and replug the formatted USB storage device for the change to take effect. Alternatively you may restart the system for the change to take effect.", 
			 1 => "<br/>Error: USB storage not formated", 
			 2 => "<br/>Error: USB storage is read only", 
			 3 => "<br/>Error: USB storage ".($forced?"is":"may be")." being accessed",
			 8 => "<br/>Error: USB storage failed; filesystem is corrupted",
			 9 => "<br/>Error: USB storage failed; filesystem is corrupted");
	echo ($formatMsg[$ret]."<br/><br/>\n");
	if ($ret==3 && ! $forced){
		echo "<form action='playerconfig.php' method='post'>";
		echo "<input type='submit' value='Format Anyways' name='format_usb'/>\n";
		echo "<input type='hidden' name='usb_key' value='$dest' />";
		echo "<input type='hidden' name='force_format'/>\n";
		echo "</form><br/>";
	}
}	

if (isset($input["unmount_usb"]) ){
	$dest=$input["usb_mountedkey"];
	echo "<h2>Status:</h2>";
	echo "Disconnecting USB storage: ".str_repeat(' ',256)."\n"; 
	ob_flush();flush();
	$flag="";
	if (isset($input["force_unmount"])) $flag="-f ";
	$unmount=exec("/usr/lib/raperca/usb-remove $flag$dest", $stdout, $ret);

	$unmountMsg=array(0 => "Sucess, USB storage device can be removed", 
			  1 => "Error, USB storage device not disconnected", 
			  2 => "Error, USB storage device is being accessed", 
			  3 => "Sucess, USB storage device can be removed");
	
	echo ($unmountMsg[$ret]."<br/><br/>");
	
	if ($ret==2){
		echo "<form action='playerconfig.php' method='post'>";
		echo "<input type='submit' value='Disconnect Anyways' name='unmount_usb'/>";
		echo "<input type='hidden' name='force_unmount'/>";
		echo "<input type='hidden' name='usb_mountedkey' value='$dest' />";
		echo "</form>";
	}
}

$infoUSB=`/usr/lib/raperca/usb-storage`;
$infoUSBlst=explode("\n",$infoUSB);
$infoUSB=array();
foreach ($infoUSBlst as $info){
	$inf=explode(":",$info);
	if ($inf!=$info && count($inf)==4 && $inf[3]>0)
		$infoUSB[]=$inf;
}
$USBAsInternal=-1;
if (count($infoUSB)>0){
	$mount=file_get_contents("/proc/mounts");
	$mounts=explode("\n",$mount);
	foreach ($mounts as $mount){
		$info=preg_split("/\s/",$mount);
		for ($i=0; $i<count($infoUSB); $i++){
			if ($infoUSB[$i][1]==$info[0]){
				if ($info[1]=='/srv/raperca/content') $USBAsInternal=$i;
				$infoUSB[$i][]=$info[1];				
				$infoUSB[$i][]=substr($info[3],0,2);
			}
		}
	}
}


if ($doShutdown){
	shutdown("player config changed");
} else {
	
if ($tabIdx==1){

echo "<script type='text/javascript'>\n";
echo "<!--\n";
echo "var serverUri=new Array();\n";


$animations = $config->getElementsByTagNameNS($svgNS,'animation');
$sources=array();
$minSource=0;
foreach ($animations as $anim){
	if ($maxSource-$anim->getAttribute("priority")<$minSource)
		$minSource=$maxSource-$anim->getAttribute("priority");
	$sources[$maxSource-$anim->getAttribute("priority")]=$anim->getAttributeNS($xlinkNS,"href");
}
if ($minSource<0) 
	for ($i=$maxSource; $i>=$minSource; $i--)
		if (isset($sources[$i]))
			$sources[$i-$minSource]=$sources[$i];
		
$hosts = $config->getElementsByTagName('virtualHost');
$hostlist=array();
foreach ($hosts as $host){
	$hostname=$host->getAttribute("host");
	$hostsplit=split("/",$hostname);
	$hostAdress=$host->getAttributeNS($xlinkNS,"href");
	if (strncmp($hostname,"project://AutoServer",20)==0)
		$hostlist[$hostname[20]]=$hostAdress;
}

for ($i=0; $i<$maxSource; $i++){
	echo "serverUri[$i]='".$hostlist[$i]."';\n";
}

?>
function enableServer(serverIdx)
{
	var selectSource=document.getElementById( "selectSource" + serverIdx  );
	
	if (selectSource.selectedIndex==1){
		document.getElementById( "inputServer" + serverIdx ).disabled=false;
		document.getElementById( "inputServer" + serverIdx ).value=serverUri[serverIdx];
	}else{
		if (!document.getElementById( "inputServer" + serverIdx ).disabled)
			serverUri[serverIdx]=document.getElementById( "inputServer" + serverIdx ).value;
		document.getElementById( "inputServer" + serverIdx ).disabled=true;
		document.getElementById( "inputServer" + serverIdx ).value="";
	}
}
-->
</script>
<form action="playerconfig.php" method="post">

<h2>Media Sources: </h2>
The player will start with the primary source. If it is not available, the fallback will be used. 

<table>
<?php

$names=array("Primary source", "Fallback source", "Fallback source (bis)", "Fallback source (ter)");

for ($i=0; $i<$maxSource; $i++){
	$serverDisabled="disabled='disabled'";
	$serverName="";
	$autoServerName="AutoServer$i";
	echo "<tr>\n<td>".$names[$i]." :</td>\n<td><select name='source$i' id='selectSource$i' onchange='enableServer($i)'>\n";
	foreach($sourceList as $name => $add){
		if ($add==""){
			$autoServerName="AutoServer$i-".rand(0,99);
			$add="project://$autoServerName/index.svg";
			if (strncmp($sources[$i],$add,21)==0){
				$serverDisabled='';
				$serverName=$hostlist[$i];
			}
		}
		if (strncmp($sources[$i],$add,21)==0)
		     echo "<option selected='selected' value=\"", htmlspecialchars($add), "\">", htmlspecialchars($name), "</option>\n";
		else
		     echo "<option value=\"", htmlspecialchars($add), "\">", htmlspecialchars($name), "</option>\n";
	}
	echo "</select></td>\n";
	echo "<td><input type='hidden' name='projectName$i' value='$autoServerName' />\n";
	echo "<input type='hidden' name='oldProjectHref$i' value=\"", htmlspecialchars($hostlist[$i]), "\" />\n";
	echo "<input size='40' type='text' name='projectHref$i' value=\"", htmlspecialchars($serverName), "\" $serverDisabled id='inputServer$i'/></td></tr>\n";
	
}
echo "</table>\n";

echo "Local Storage set to : ";
if ($USBAsInternal!=-1){
	echo "<input value='USB storage' size='15' disabled='disabled'/>\n";
}else{
	echo "<input size='25' value='$product internal storage' disabled='disabled'/>\n";
}
if ($USBAsInternal!=-1) {
	echo "<input type='submit' value='Clear $product internal storage' name='clear_hmp100'/>\n";
}
echo '<br/><br/>';

$checked="";
if ($useUSB )$checked="checked='checked' ";
echo "<input type='checkbox' value='yes' name='enable_usb' $checked/>Set Local Storage to USB storage device when available.<br/><br/>\n";
echo "<input type='submit' value='Apply' name='update'/><br/>\n</form>\n<br/>\n";

echo "<h2>Detected USB Storage devices:</h2>";
echo "<br/><p>Note: it may take some time for a USB storage device to be fully recognized, reload this page if you think the information below is not accurate.</p>\n";
if (count($infoUSB)==0){
     echo "<p>No USB storage devices (e.g., USB stick) currently attached.</p>\n";
}
echo "<form action='playerconfig.php' method='get'>\n";
echo "<input type='submit' value='Reload'/>\n";
echo "</form><br/>\n";

$devnr=0;
foreach ($infoUSB as $inf) {
     $devnr++;
     echo "<h2>Device # $devnr:</h2>\n";
	echo "<form action='playerconfig.php' method='post'>\n";
	$isWritable=isset($inf[5]) && $inf[5]=="rw";
	
	echo "<table>\n";
	echo "<tr><td>Storage size: </td><td>".(floor($inf[3]/2048))." Mbytes</td></tr>";
	$isLocalStorage = ($inf[4]=='/srv/raperca/content');
	$isUpdates = ($inf[4]=='/media/usb1');
	if (!isset($inf[4])) echo "<tr><td>Not currently in use</td></tr>\n";
	else{
	     echo "<tr><td>Used for: </td><td>".($isLocalStorage?"Local Storage":($isUpdates?"Updates":"None"))."</td></tr>";
	     if ($isLocalStorage) {
		  echo "<tr><td>Writable: </td><td>".($isWritable?"yes":"no")."</td></tr>";
	     }
	}
	echo "</table>\n";
	if (isset($inf[4])){
	     echo "<input type='hidden' name='usb_mountedkey' value=\"".htmlspecialchars($infoUSB[0][1])."\"/>\n";
		echo "<input type='submit' value='Disconnect' name='unmount_usb'/><br/><br/>";
	}
	
	if (!$isWritable && $isLocalStorage)
	     echo "USB storage is connected as read-only.\n";
	echo "USB storage must be specially formatted to use it as writable local storage, otherwise it is used as read-only.<br/><br/>";
	echo "Warning: formating a USB storage device erases all content on it.<br/><br/>\n";
	echo "<input type='hidden' name='usb_key' value=\"".htmlspecialchars($inf[0])."\"/>\n";
	echo "<input type='submit' value='Format Now' name='format_usb'/>\n";
	
	
	echo "</form><br/>";
}	

} else {
// advanced mode


$projects = $config->getElementsByTagName('virtualHost');
$projectlist=array();
$hasProject=false;
foreach ($projects as $proj){
	$hostname=$proj->getAttribute("host");
	$hostsplit=split("/",$hostname);
	$hostAdress=$proj->getAttributeNS($xlinkNS,"href");
	if (strncmp($hostsplit[2],"AutoServer", 10) == 0)
		$projectlist[]=array($hostsplit[2],$hostAdress, false);
	else{
		$projectlist[]=array($hostsplit[2],$hostAdress, true);
		$hasProject=true;
	}
}
if (!$hasProject)
	$projectlist[]=array("","", true);

$hosts = $pass_config->getElementsByTagName('creditentials');
$hostlist=array();
foreach ($hosts as $host){
	$href=$host->getAttributeNS($xlinkNS,"href");
	$username=$host->getAttribute("username");
	$pass=$host->getAttribute("password");
	$realm=$host->getAttribute("realm");
	if ( ! $host->hasAttribute("xml:id") )
		$hostlist[]=array($href, $username, $pass, $realm);
}
if (count($hostlist)==0)
	$hostlist[]=array("","","","");

?>

<script type="text/javascript">
<!--

function addNewServer()
{
	var tableServer=document.getElementById("serverDef");
	var nbServer=tableServer.rows.length-1;
	var newRow=tableServer.insertRow(nbServer);
	
	var cell1 = newRow.insertCell(0);
	var cell2 = newRow.insertCell(1);
	var cell3 = newRow.insertCell(2);
	var cell4 = newRow.insertCell(3);
	var text1="<input size='35' type='text' name='serverHref" + nbServer + "' value=''/>\n";
	var text2="<input size='10' type='text' name='serverName" + nbServer + "' value=''/>\n";
	var text3="<input size='10' type='password' name='serverPass" + nbServer + "' value=''/>\n";
	var text4="<input size='10' type='text' name='serverRealm" + nbServer + "' value=''/>\n";
	cell1.innerHTML=text1;
	cell2.innerHTML=text2;
	cell3.innerHTML=text3;
	cell4.innerHTML=text4;
}

function addNewProject()
{
	var tableServer=document.getElementById("projectDef");
	var nbServer=tableServer.rows.length-1;
	var newRow=tableServer.insertRow(nbServer);
	var cell1 = newRow.insertCell(0);
	var cell2 = newRow.insertCell(1);
	var text1="<input size='20' type='text' name='projectName" + nbServer + "' value='' />";
	var text2="<input size='40' type='text' name='projectHref" + nbServer + "' value=''/>";
	cell1.innerHTML=text1;
	cell2.innerHTML=text2;
}
-->
</script>

<form action='playerconfig.php' method='post'>
<h2>Network Credentials: </h2>
Use the table below to defined usernames and passwords for network sources. 
Optionally you can specify different usernames and passwords depending on the realm returned by the server.  
<table id="serverDef">
<tr><td>Server URI</td><td>Username</td><td>Password</td><td>Realm</td></tr>
<tr>
<td><input size='35' type='text' disabled='disabled' value='http://SomeServer/SomePath/'/></td>
<td><input size='10' type='text' disabled='disabled' value='MyName'/></td>
<td><input size='10' type='password' disabled='disabled' value='MyPassword'/></td>
<td><input size='10' type='text' disabled='disabled' value=''/></td>
</tr>
<?php
$hostIdx=0;
foreach ($hostlist as $server){
     print("<tr>\n<td><input size='35' type='text' name='serverHref$hostIdx' value=\"". htmlspecialchars($server[0]). "\"/></td>\n");
     print("<td><input size='10' type='text' name='serverName$hostIdx' value=\"". htmlspecialchars($server[1]). "\"/></td>\n");
     print("<td><input size='10' type='password' name='serverPass$hostIdx' value=\"". htmlspecialchars($server[2]). "\"/></td>\n");
     print("<td><input size='10' type='text' name='serverRealm$hostIdx' value=\"". htmlspecialchars($server[3]). "\"/></td>\n</tr>\n");
	$hostIdx++;
}
?>
<tr><td/><td/><td colspan='2' align='right'><input type="button" value="Add server row" onclick="addNewServer()" /></td></tr>
</table>

<?php if ($advancedMode) { ?>
<h2>Shared Projects: </h2>
Use the table below to define the location of the shared projects.  
<table id="projectDef">
<tr><td>Shared project name</td><td>Project URI</td></tr>
<tr><td><input size='20' type='text' disabled='disabled' value='SampleProject' /></td>
<td><input size='40' type='text' disabled='disabled' value='http://SampleServer.com/SampleProjectPath/'/></td>
</tr>
<?php
$hiddenProject = "";
$hostIdx=0;
foreach ($projectlist as $project){
	if ($project[2]){
	     print("<tr><td><input size='20' type='text' name='projectName$hostIdx' value=\"". htmlspecialchars($project[0]). "\" /></td>\n");
	     print("<td><input size='40' type='text' name='projectHref$hostIdx' value=\"". htmlspecialchars($project[1]). "\"/></td>\n</tr>\n");
	}else{
	     $hiddenProject .= "<input type='hidden' name='projectName$hostIdx' value=\"". htmlspecialchars($project[0]). "\" />\n";
	     $hiddenProject .="<input type='hidden' name='projectHref$hostIdx' value=\"". htmlspecialchars($project[1]). "\" />\n";
	}
	$hostIdx++;
}
?>
<tr><td></td><td></td><td align='right'><input type="button" value="Add project row" onclick="addNewProject()" /></td></tr>
</table>
<?php
echo $hiddenProject;
}
?>
Press Apply to save your changes.<br/>
<input type="submit" value="Apply" name="update_adv" />
<input type='hidden' name='tabs' value='2' />
</form>
<?php
}

} // not shutdown
include "final.php";
?>