<?php 
header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
header("Expires: Sat, 13 Jan 1973 15:55:00 GMT"); // Date in the past
?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<?php
$branding_file="/usr/share/resources/default/interface/branding.php";
if (file_exists($branding_file) ){
	include $branding_file;
}else {
	// default strings:
	$vendor = "[not Defined]";
	$product = "[not Defined]";
	$maintitle = "[not Defined]";
	$copyrights = "Copyright  2009 SpinetiX SA. All rights reserved.";
	$email = "support@spinetix.com";
	$icon="";
	$csspage="";
	$productimage="";
	
	
	$linkiphelp="(see <a href='http://www.spinetix.com/UserguideHMP/GetConnected'>GetConnected</a>)";
	$linkfirmware="<a href='http://www.spinetix.com/firmware'>http://www.spinetix.com/firmware</a>";
	$linklicense="download.spinetix.com/sources/";
}
if (!isset($releasepkg)) $releasepkg="spx-release";

echo "<link rel='shortcut icon' href='css/$icon' type='image/x-icon' />\n";
echo "<style type='text/css' media='all'>@import 'css/$csspage';</style>\n";

$licenseinfo=file_get_contents("/var/run/raperca/licenses_info");
if ($licenseinfo!==false) {
	$domdoc = new DOMDocument;
	if ($domdoc->loadXML($licenseinfo)!==false) {
		$licenses=array();
		$features=$domdoc->getElementsByTagName("feature");
		foreach ($features as $feat) {
			$name = $feat->getElementsByTagName("name");
			if (count($name)>0) {
				$name = $name->item(0)->textContent;
				$valid = $feat->getElementsByTagName("valid");
				if (count($valid)>0) {
					$valid = $valid->item(0)->textContent;
					if ( $valid=="true" ) {
						$info = array();
						$exp = $feat->getElementsByTagName("expire");
						if ( $exp->length>0 ) {
							$info['expire'] = $exp->item(0)->textContent;
						} else {
							$info['expire'] = "never";
						}
						$exp = $feat->getElementsByTagName("source");
						if ( $exp->length>0 ) {
							$info['source'] = $exp->item(0)->textContent;
						}
						$licenses[$name] = $info;
					} else {
						$licenses[$name] = false;
					}
				} else{
					$licenses[$name] = false;
				}
			}
		}
	}
} 
if (!isset($title)) $title="";
$cpuinfo=file_get_contents("/proc/cpuinfo");
if (preg_match("/Serial\s+:\s+(\S+)/",$cpuinfo,$match))
	$serial=$match[1];
else
	$serial="<unknown>";
	
if (preg_match("/[0-9a-f]{12}/",$serial)){	
	$serialstring=$serial[0].$serial[1]."-".$serial[2].$serial[3]."-".$serial[4].$serial[5]."-".$serial[6].$serial[7]."-".$serial[8].$serial[9]."-".$serial[10].$serial[11];
	$devicename="#".htmlspecialchars($serial);
} else {
	// this is not an MAC
	$serialstring=$serial;
	$devicename="";
}
echo "<title>$product $devicename: $title</title>";

?>

</head>

<?php
# If we already have the helpers do not include it again
include_once "helpers.php";

$pagesInfo=array("Status"=>"welcome.php",
				"Snapshot"=>"preview.php",
				"Display Info"=>"screeninfo.php",
				"Storage"=>"content.php",
				"Logs" => "logs.php"
				);
$pagesSettings=array(
				"Display Settings"=>"displayconfig.php",
				"Network Settings"=>"ipconfig.php",
				"Media Sources"=>"playerconfig.php",
				"Security"=>"accessconfig.php",
				"Date/Time"=>"timesettings.php",
				"RS232 / USB IO"=>"comport.php",
				"Pull Mode"=>"uploader.php",
				"Firmware Update"=>"update.php",
				"Maintenance"=>"systemconfig.php");
$pagesAdvanced=array(
		"Player" => "advplayerconfig.php",
		"Logs Settings"	 =>"logconfig.php",
		"Cache Settings"	 =>"advcacheconfig.php");
		
		
$advancedMode=false;
$query="";
$queryMulti="";
if (isset($_GET['advanced']) || isset($_POST['advanced']) || isset($pagesAdvanced[$title])){
	$advancedMode=true;
	$query="?advanced=1";	
	$queryMulti="&advanced=1";	
}
	
//check safe mode
$safemode=file_exists("/var/run/raperca.safe");

//check installation mode
$installationmode=file_exists("/var/run/reboot-delayed");
if (isset($_POST['instalation_mode'])){
	if ( $_POST['instalation_mode']=='Enable') $installationmode=true;
	if ( $_POST['instalation_mode']=='Disable') $installationmode=false;
}
//check firmware
$statusfn="/var/lib/updater/status";
if (!file_exists($statusfn)) $firmwareOK=true;
else $firmwareOK = ( trim(file_get_contents($statusfn))!="CORRUPTED" );
?>

<body>
<div id="page">
<div id="wrapper">
<div id="header">
<?php
	echo "<h1>$maintitle</h1>";
?>
</div>
<div id="sidebar" >
<div id="sidebar-left">
<?php
if ($safemode) {
?>
<h3 class="red dbx-handle">Safe Mode</h3>
<div class="dbx-content">
	<ul class="menu">	
	<li class='leaf'><a href='safemode.php'>Information</a></li>
	</ul>
</div>	
<?php
}
?>

<h3 class="dbx-handle">Information</h3>
<div class="dbx-content">
	<ul class="menu">			
<?php
foreach ($pagesInfo as $pageName => $pageURI){
	if ($pageURI==""){
		echo "<li class='leaf'> </li>";
	}else if ($title==$pageName){
	     echo "<li class='leaf'><a href=\"", htmlspecialchars("$pageURI$query"), "\" class='active'>$pageName</a></li>";
	}else{
	     echo "<li class='leaf'><a href=\"", htmlspecialchars("$pageURI$query"), "\">$pageName</a></li>";
	}
} 
?>
	</ul>
</div>
<h3 class="dbx-handle">Administration</h3>
<div class="dbx-content">
	<ul class="menu">			
<?php
foreach ($pagesSettings as $pageName => $pageURI){
	if ($pageURI==""){
		echo "<li class='leaf'> </li>";
	}else if ($title==$pageName){
	     echo "<li class='leaf'><a href=\"", htmlspecialchars("$pageURI$query"), "\" class='active'>$pageName</a></li>";
		$acitveUri=$pageURI;
	}else{
	     echo "<li class='leaf'><a href=\"", htmlspecialchars("$pageURI$query"), "\">$pageName</a></li>";
	}
} 
?>
	</ul>
</div>
<?php
if ($advancedMode){
echo "<h3 class='dbx-handle'>Advanced</h3>";
echo "<div class='dbx-content'>";
echo "	<ul class='menu'>";			

foreach ($pagesAdvanced as $pageName => $pageURI){
	if ($pageURI==""){
		echo "<li class='leaf'> </li>";
	}else if ($title==$pageName){
	     echo "<li class='leaf'><a href=\"", htmlspecialchars($pageURI), "\" class='active'>$pageName</a></li>";
		$acitveUri=$pageURI;
	}else{
	     echo "<li class='leaf'><a href=\"", htmlspecialchars($pageURI), "\">$pageName</a></li>";
	}
} 
echo "	</ul>";
echo "</div>";
	}
	
echo "<h3 class='dbx-handle'>Serial Number</h3>";
echo "<div class='dbx-content'>";
echo "<ul class='menu'>";
echo "<li>$serialstring</li>";
echo "</ul>";
echo "</div>";
			
?>
</div>
</div>

<div id="left-col">

<?php

if (isset($tabs) && !isset($tabIdx)) {
	
	if (isset($_GET['tabs']))	
		$tabIdx=$_GET['tabs'];
	elseif (isset($_POST['tabs']))	
		$tabIdx=$_POST['tabs'];
	else
		$tabIdx=1;
}
if (isset($tabs) && isset($tabIdx)){
	
	echo "<div id='navtab$tabIdx' >";
	$idx=1;
	foreach ($tabs as $name){
		$className="tab".$idx;
		echo "<a class='$className' href=\"", htmlspecialchars("$acitveUri?tabs=$idx$queryMulti"), "\">$name</a>";
		$idx++;
	}
}else
	echo "<div id='nav' >";
?>
</div>
<div id="content">
<?php
if ( !isset($licenses) )
	$licenses = array();
elseif (!isset($licenses['HMP']) || $licenses['HMP']===false) {
	echo "<h2 class='red'>No valid player license found</h2>\n";
	echo "The $product is missing the player license, it will not display any content on the screen. Please contact $vendor support (<a href='mailto:$email'>$email</a>)<br/><br/>\n";
}
if (!$firmwareOK) {
?>
<h2 class="red">Corrupted Firmware</h2>
<br/>
<p>
<?php echo "The current install of the $product firmware is corrupted.\n";?> 
This has probably been caused by a power cut during a firmware upgrade. 
In this case the system becomes corrupted, no further updates are possible and your system may be unstable.
</p>
<p>
To recover from this state do the following:
</p>
<ul>
<?php 
echo "	<li>Restart the $product in diagnostics mode by clicking the \"Restart Now\" button below.</li>\n"; 
echo "	<li>Allow for up to 2 mins for the $product to restart in diagnostics mode (a.k.a. recovery console).</li>\n"; 
echo "	<li>Open the recovery console on a web browser by typing the $product's IP address in the URL bar (depending on your IP configuration the $product might use an address in the range of 192.168.1.10 to 192.168.1.29)</li>\n";
echo "	<li>Click on the install factory image button, this will reinstall the factory firmware from scratch.</li>\n";
echo "	<li>Wait until the page shows that the install process is finished, if your browser times out you can repeatedly reload the page until it shows that the install is finished.</li>\n";
echo "	<li>Now your $product is back with the factory firmware and with factory default configuration as if it was a new unit.</li>\n";
echo "	<li>Click the reboot button. Note that after reboot the IP address will be 192.168.1.10 $linkiphelp.</li>\n";
?>
</ul>
<p>
<?php 
echo "After this you need to reconfigure the network settings of your $product and then you can restart the firmware upgrade,\n"; 
echo "but do not cut down the power to the HMP during the firmware upgrade even if you see a big OK message on the web page. \n";
echo "Let the upgrade process restart your HMP automatically. ";
if ($linkfirmware!="")
	echo "For more details see $linkfirmware\n";
?>
</p>
<p>
<?php echo "In case of problems, please contact $vendor support (<a href='mailto:$email'>$email</a>)\n";?> 
</p>
<h2>Diagnostic Mode Restart</h2>
<br/>
<p>
<?php echo "	 Pressing 'Restart Now' will restart the $product in diagnostic (i.e., recovery) mode with the same network address, if one has been configured,\n"; ?> 
<?php echo "     or with a free IP address in the range of 192.168.1.10 to 192.168.1.29 otherwise.<br/>\n"; ?>
</p>
<form action="systemconfig.php" method="post" >
<input type="submit" value="Restart Now" name="rebootrecovery" /><br/>
</form>
<br/>  
<br/>
<?php
}
?>
<?php
if ( $installationmode ) {
	echo "<h2 class='red'>Installation Mode</h2>";
	echo "<p>The $product is curently in instalation mode. Configuration changes will only be activated unpon restart.</p>";
	$pending=file_get_contents("/var/run/reboot-pending");
	if (!($pending===false)){
		echo "<p>Pending changes:</p>";
		$lines = explode("\n",$pending);
		echo "<ul>";
		foreach ($lines as $line) {
			if ($line!="") echo "<li>$line</li>";
		}
		echo "</ul>";
		echo "<form action='systemconfig.php' method='post' >";
		echo "<input type='submit' value='Restart Now' name='reboot' /><br/><br/>";
		echo "</form>";
	}
}
?>
